/*----- PROTECTED REGION ID(KeithleyMultimetersStateMachine.cpp) ENABLED START -----*/
static const char *RcsId = "$Id:  $";
//=============================================================================
//
// file :        KeithleyMultimetersStateMachine.cpp
//
// description : State machine file for the KeithleyMultimeters class
//
// project :     Keithley multimeters device
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
// $Author:  $
//
// $Revision:  $
// $Date:  $
//
// $HeadURL:  $
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================

#include "KeithleyMultimeters.h"

/*----- PROTECTED REGION END -----*/	//	KeithleyMultimeters::KeithleyMultimetersStateMachine.cpp

//================================================================
//  States   |  Description
//================================================================
//  RUNNING  |  Acquisition is on the way
//  STANDBY  |  Ready for a new acquisition
//  FAULT    |  Device initailisation failed or an error occured


namespace KeithleyMultimeters_ns
{
//=================================================
//		Attributes Allowed Methods
//=================================================

//--------------------------------------------------------
/**
 *	Method      : KeithleyMultimeters::is_nPLC_allowed()
 *	Description : Execution allowed for nPLC attribute
 */
//--------------------------------------------------------
bool KeithleyMultimeters::is_nPLC_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for nPLC attribute in Write access.
	/*----- PROTECTED REGION ID(KeithleyMultimeters::nPLCStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	KeithleyMultimeters::nPLCStateAllowed_WRITE

	//	Not any excluded states for nPLC attribute in read access.
	/*----- PROTECTED REGION ID(KeithleyMultimeters::nPLCStateAllowed_READ) ENABLED START -----*/
	if (get_state() == Tango::RUNNING	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
		
		/*----- PROTECTED REGION END -----*/	//	KeithleyMultimeters::nPLCStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : KeithleyMultimeters::is_triggerSource_allowed()
 *	Description : Execution allowed for triggerSource attribute
 */
//--------------------------------------------------------
bool KeithleyMultimeters::is_triggerSource_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for triggerSource attribute in Write access.
	/*----- PROTECTED REGION ID(KeithleyMultimeters::triggerSourceStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	KeithleyMultimeters::triggerSourceStateAllowed_WRITE

	//	Not any excluded states for triggerSource attribute in read access.
	/*----- PROTECTED REGION ID(KeithleyMultimeters::triggerSourceStateAllowed_READ) ENABLED START -----*/
	if (get_state() == Tango::RUNNING	||
		get_state() == Tango::FAULT)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
		
		/*----- PROTECTED REGION END -----*/	//	KeithleyMultimeters::triggerSourceStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : KeithleyMultimeters::is_nbPoints_allowed()
 *	Description : Execution allowed for nbPoints attribute
 */
//--------------------------------------------------------
bool KeithleyMultimeters::is_nbPoints_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for nbPoints attribute in Write access.
	/*----- PROTECTED REGION ID(KeithleyMultimeters::nbPointsStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	KeithleyMultimeters::nbPointsStateAllowed_WRITE

	//	Not any excluded states for nbPoints attribute in read access.
	/*----- PROTECTED REGION ID(KeithleyMultimeters::nbPointsStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	KeithleyMultimeters::nbPointsStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : KeithleyMultimeters::is_nbBufferizedPoints_allowed()
 *	Description : Execution allowed for nbBufferizedPoints attribute
 */
//--------------------------------------------------------
bool KeithleyMultimeters::is_nbBufferizedPoints_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for nbBufferizedPoints attribute in read access.
	/*----- PROTECTED REGION ID(KeithleyMultimeters::nbBufferizedPointsStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	KeithleyMultimeters::nbBufferizedPointsStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : KeithleyMultimeters::is_data_allowed()
 *	Description : Execution allowed for data attribute
 */
//--------------------------------------------------------
bool KeithleyMultimeters::is_data_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for data attribute in read access.
	/*----- PROTECTED REGION ID(KeithleyMultimeters::dataStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	KeithleyMultimeters::dataStateAllowed_READ
	return true;
}

//=================================================
//		Commands Allowed Methods
//=================================================

//--------------------------------------------------------
/**
 *	Method      : KeithleyMultimeters::is_ReadBufferedData_allowed()
 *	Description : Execution allowed for ReadBufferedData attribute
 */
//--------------------------------------------------------
bool KeithleyMultimeters::is_ReadBufferedData_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for ReadBufferedData command.
	/*----- PROTECTED REGION ID(KeithleyMultimeters::ReadBufferedDataStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	KeithleyMultimeters::ReadBufferedDataStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : KeithleyMultimeters::is_WriteRead_allowed()
 *	Description : Execution allowed for WriteRead attribute
 */
//--------------------------------------------------------
bool KeithleyMultimeters::is_WriteRead_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for WriteRead command.
	/*----- PROTECTED REGION ID(KeithleyMultimeters::WriteReadStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	KeithleyMultimeters::WriteReadStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : KeithleyMultimeters::is_Abort_allowed()
 *	Description : Execution allowed for Abort attribute
 */
//--------------------------------------------------------
bool KeithleyMultimeters::is_Abort_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for Abort command.
	/*----- PROTECTED REGION ID(KeithleyMultimeters::AbortStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	KeithleyMultimeters::AbortStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : KeithleyMultimeters::is_Configure_allowed()
 *	Description : Execution allowed for Configure attribute
 */
//--------------------------------------------------------
bool KeithleyMultimeters::is_Configure_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for Configure command.
	/*----- PROTECTED REGION ID(KeithleyMultimeters::ConfigureStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	KeithleyMultimeters::ConfigureStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : KeithleyMultimeters::is_StartAcquisition_allowed()
 *	Description : Execution allowed for StartAcquisition attribute
 */
//--------------------------------------------------------
bool KeithleyMultimeters::is_StartAcquisition_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for StartAcquisition command.
	/*----- PROTECTED REGION ID(KeithleyMultimeters::StartAcquisitionStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	KeithleyMultimeters::StartAcquisitionStateAllowed
	return true;
}

}	//	End of namespace
